
//PWM_controller

// LCD module connections
sbit LCD_RS at RB2_bit;
sbit LCD_EN at RB3_bit;
sbit LCD_D4 at RB4_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D7 at RB7_bit;
sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;
// End LCD module connections

// Declare variables
char select=0, state=1;

void main() {

  ANSEL = 0; // all pins set as digital inputs o outputs
  TRISB0_bit=1;     // RB0 sets as digital input
  TRISC = 0;
  PORTC = 0;       // clear PORTC
  ANSELH = 0;
  C1ON_bit = 0;    // analog comparators off
  C2ON_bit = 0;
  PWM1_Init(1000);      //PWM frecuency=1khz
  PWM1_Start();
  Lcd_Init();
  Lcd_Cmd(_LCD_CLEAR);
  Lcd_Cmd(_LCD_CURSOR_OFF);
  Lcd_Out(1,1,"PWM_controller");

  do {
      if (Button(&PORTB,0,1,0)) state=0;     //if the button has been pushed.
      if (state==0 && Button(&PORTB,0,1,1)){ //if after that is free
      select++;
      if (select>5) select=0;
      state=1;
      }
      switch (select){
      case 0:
      Lcd_Out(2,1,"cycle_duty:  0%");
      PWM1_Set_Duty(0);
      break;
      case 1:
      Lcd_Out(2,1,"cycle_duty: 20%");
      PWM1_Set_Duty(51);
      break;
      case 2:
      Lcd_Out(2,1,"cycle_duty: 40%");
      PWM1_Set_Duty(102);
      break;
      case 3:
      Lcd_Out(2,1,"cycle_duty: 60%");
      PWM1_Set_Duty(153);
      break;
      case 4:
      Lcd_Out(2,1,"cycle_duty: 80%");
      PWM1_Set_Duty(204);
      break;
      case 5:
      Lcd_Out(2,1,"cycle_duty:100%");
      PWM1_Set_Duty(255);
      break;
   }
   delay_ms(5);
 }while(1);
}